import java.awt.*;
import java.applet.Applet;
import java.applet.AppletContext;
import java.util.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.lang.Object;
import java.lang.Character;

/**
 * An application that opens a connection to a web server and reads
 * a single web page from the connection.
 */
public class wetnet_chat extends Applet implements Runnable {

  Font appFont = new Font("Courier",Font.PLAIN,12);
  TextArea textArea1;
  TextArea textArea2;
  TextField textField1;
  Button b1 = new Button(" Connect  ");
  Button b3 = new Button("---------- Transmit ----------");
  String responseLine = "";
  DataOutputStream outbound;
  DataInputStream  inbound;
  Socket clientSocket;
  boolean xconnected = false;
  boolean login = false;
  Thread thread;
  int MAXSIZE = 150;
  int DELTA = 50;
  int linecount = 0;

 

    public void init()
    {

       textField1 = new TextField("CALLSIGN",10);

       textArea1 = new TextArea("",15, 82);
       textArea1.setEditable(false); 
       textArea1.setFont(appFont);
       textArea1.setBackground(new Color(0xE0FFFF)); 

       textArea2 = new TextArea("",3, 82);
//      textArea2 = new TextField("",80);
       textArea2.setEditable(true); 
       textArea2.setFont(appFont);
       textArea2.setBackground(new Color(0xE0FFFF)); 
 
 
//       add(new Label("MyCall = "));
       add (textField1);
       add(b1); 
       add (textArea1);      
       add(b3); 
       add(textArea2);

       setBackground(new Color(0xFFF0D0));
       textArea1.setText(" JAVA conference bridge by Bill Bytheway - AA6ED\n\n" +
                         " This window is the Babble Window used for receiving DATA,\n" +
                         " the bottom window is used to send/transmit your message.\n\n");
       textArea2.setText(" This window is used to send/transmit commands and messages,\n" +
                         " after typing in your message, press TRANSMIT.\n" +
                         " System will now try to log you on to WETNET Comverence Bridge");
       repaint();
   }

   public void start()
    {
//       textArea1.appendText("Starting thread\n");
      thread = new Thread(this); 
        if (thread.isAlive())
            thread.resume();
        else
            thread.start();
    }

    public void stop()
    {
//        textArea1.appendText("Stop\n");
        thread.suspend();
    }

    public void destroy()
    {
      thread.stop();
    }
  
    public void run()
    {
//      textArea1.appendText("Running getpage\n");      
        while (xconnected)
        {
            getPage();
            try
            {
               thread.sleep(100);
            }
               catch (InterruptedException e)
            {}
         }
    }

    public boolean connectPage()
    {
        try
        {
            // Open a client socket connection
            clientSocket = new Socket("wetnet.wa.com", 3600);
////////////clientSocket = new Socket("44.24.103.157", 23);
                //
                // other port numbers are
                // echo 7
                // daytime 13
//line100                // ftp 21
                // telnet 23
                // finger 79
                // http 80
            textArea1.appendText("\r\nClient: " + clientSocket + "\n");
 outbound = new DataOutputStream(clientSocket.getOutputStream());
 inbound = new DataInputStream(new BufferedInputStream(clientSocket.getInputStream()));


            // Successful connect
            xconnected = true;
      
        }
        catch (UnknownHostException uhe)
        {
            textArea1.appendText("\r\nUnknownHostException: " + uhe);
        }
        catch (IOException ioe)
        {
            textArea1.appendText("\r\nIOException: " + ioe);
        } 
         if (xconnected)
            return true; 
         else
            return false;
    }

    /**
     * Request a web page using the passed client socket.
     * Display the reply and close the client socket.
     */
    public void getPage()
    {
    int mychar;
    String s = "";
    String t;
    String outLine;
    int i =0;
    int j = 0;
    int k;
         try
        {
          while (inbound.available() > 0) 
//           while ((mychar = inbound.read()) > 0)
          {
            mychar = inbound.read();
            if ((char)mychar == -1) doDisconnect();
            s = s + (char)mychar;
            if ((char)mychar == '\n')
             {
                 linecount++;
                 textArea1.appendText(s);
                 if (!login && (s.charAt(0) == '*'))
                 {
                   login = true;
                   outLine = "/name " + textField1.getText() + " 4424\n/who *\n";
                   outbound.writeBytes(outLine);
                   textArea1.appendText(outLine);
             //    outbound.writeBytes("/topic Washington Experimenters TCP/IP Network (WETNET)\n");
                   outbound.writeBytes("/topic Western Washington TCP/IP users;  Net: 44.24.x.x\n");

                  }   
                  s = "";
             }      
          
           if (linecount > MAXSIZE) 
           {
                i = 0;
                k = textArea1.getText().length();
                t = textArea1.getText();
                for (j = 0; j < k; j++) 
               {
                   if (t.charAt(j) == '\n') i++;
                   if (i >= DELTA)  break;
               }
              linecount -= DELTA;
              textArea1.setText(textArea1.getText().substring(j+1));
           }    
     }    
           if (s.length() > 0)                     //partial line
             textArea1.appendText(s);

        }
        catch (IOException ioe)
        {
            textArea1.appendText("\r\nIOException: " + ioe);
        }
    }


  public void doDisconnect()
  {
    xconnected = false;
    login = false;
    textField1.setEditable(true); 
    textField1.setBackground(new Color(0xFFFFFF)); 
    textArea1.appendText("\r\nDisconnected");
    b1.setLabel(" Connect  ");
    repaint();
    try   // try now to close the connection 
    {
    outbound.writeBytes("/bye\n");
    clientSocket.close();
    outbound.close();
    inbound.close();
     }
     catch (IOException ioe)
     {
      textArea1.appendText("\r\nIOException: " + ioe);
     }
    stop();   // the thread
  }

  public boolean iscallsign(String call)
  {
   int gotdigit = 0;

    for (int i=0;i<call.length(); i++)
    {
     if (Character.isDigit(call.charAt(i))) gotdigit++;
    }
    if (call.length() < 10 && call.length() > 3 && (gotdigit < 3) && (gotdigit > 0))
      return true;
    else
    {
      textArea1.appendText("\r\nERROR: Please enter valid callsign.");
      return false;
    }
   }


  public boolean action(Event evt, Object arg) 
  { 
   String outLine;
    try
     { 
        if ("Disconnect".equals(arg) && (xconnected == true)) 
        {                   
           doDisconnect();
        }

        if (" Connect  ".equals(arg) && (xconnected == false)) 
        { 
          if (iscallsign(textField1.getText()) && connectPage()) 
          {
            start();               // connectPage and runs pageGet
            textArea1.appendText("Connecting . . . .\n"); 
            b1.setLabel("Disconnect");
            textField1.setEditable(false); 
            textField1.setBackground(new Color(0xFFFF00)); 
            textArea2.setText(""); 
            repaint();
          }
        }

        if ("---------- Transmit ----------".equals(arg) && (xconnected == true)) 
        {
          outLine = textArea2.getText();          
          textArea1.appendText(outLine + "\n");
          outLine = outLine.replace('\n',' ');
          outbound.writeBytes(outLine + "\n");
          textArea2.setText(""); 
          repaint();
        }
     }
     catch (IOException ioe)
     {
      textArea1.appendText("\r\nIOException: " + ioe);
     }
    return true;
   }
}        
